diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/mgt-headers.h ns-3.39/src/wifi/model/mgt-headers.h
--- ns-3.38/src/wifi/model/mgt-headers.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/mgt-headers.h	2023-07-05 14:23:48.113428400 -0700
@@ -1821,6 +1105,65 @@
     uint16_t m_reasonCode; //!< Not used for now. Always set to 1: "Unspecified reason"
 };
 
+/**
+ * \ingroup wifi
+ * Implement the header for Action frames of type EML Operating Mode Notification.
+ */
+class MgtEmlOperatingModeNotification : public Header
+{
+  public:
+    MgtEmlOperatingModeNotification() = default;
+
+    /**
+     * Register this type.
+     * \return The TypeId.
+     */
+    static TypeId GetTypeId();
+    TypeId GetInstanceTypeId() const override;
+    void Print(std::ostream& os) const override;
+    uint32_t GetSerializedSize() const override;
+    void Serialize(Buffer::Iterator start) const override;
+    uint32_t Deserialize(Buffer::Iterator start) override;
+
+    /**
+     * EML Control field.
+     */
+    struct EmlControl
+    {
+        uint8_t emlsrMode : 1;                  //!< EMLSR Mode
+        uint8_t emlmrMode : 1;                  //!< EMLMR Mode
+        uint8_t emlsrParamUpdateCtrl : 1;       //!< EMLSR Parameter Update Control
+        uint8_t : 5;                            //!< reserved
+        std::optional<uint16_t> linkBitmap;     //!< EMLSR/EMLMR Link Bitmap
+        std::optional<uint8_t> mcsMapCountCtrl; //!< MCS Map Count Control
+        // TODO Add EMLMR Supported MCS And NSS Set subfield when EMLMR is supported
+    };
+
+    /**
+     * EMLSR Parameter Update field.
+     */
+    struct EmlsrParamUpdate
+    {
+        uint8_t paddingDelay : 3;    //!< EMLSR Padding Delay
+        uint8_t transitionDelay : 3; //!< EMLSR Transition Delay
+    };
+
+    /**
+     * Set the bit position in the link bitmap corresponding to the given link.
+     *
+     * \param linkId the ID of the given link
+     */
+    void SetLinkIdInBitmap(uint8_t linkId);
+    /**
+     * \return the ID of the links whose bit position in the link bitmap is set to 1
+     */
+    std::list<uint8_t> GetLinkBitmap() const;
+
+    uint8_t m_dialogToken{0};                             //!< Dialog Token
+    EmlControl m_emlControl{};                            //!< EML Control field
+    std::optional<EmlsrParamUpdate> m_emlsrParamUpdate{}; //!< EMLSR Parameter Update field
+};
+
 } // namespace ns3
 
 #endif /* MGT_HEADERS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-ht/dsss-phy.cc ns-3.39/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.38/src/wifi/model/non-ht/dsss-phy.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/non-ht/dsss-phy.cc	2023-07-05 14:23:48.113428400 -0700
@@ -200,8 +200,7 @@
     NS_LOG_FUNCTION(this << psdus << txVector << ppduDuration);
     return Create<DsssPpdu>(psdus.begin()->second,
                             txVector,
-                            m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(
-                                txVector.GetChannelWidth()),
+                            m_wifiPhy->GetOperatingChannel(),
                             ppduDuration,
                             ObtainNextUid(txVector));
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-ht/dsss-ppdu.cc ns-3.39/src/wifi/model/non-ht/dsss-ppdu.cc
--- ns-3.38/src/wifi/model/non-ht/dsss-ppdu.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/non-ht/dsss-ppdu.cc	2023-07-05 14:23:48.113428400 -0700
@@ -24,6 +24,7 @@
 #include "dsss-phy.h"
 
 #include "ns3/log.h"
+#include "ns3/wifi-phy-operating-channel.h"
 #include "ns3/wifi-phy.h"
 #include "ns3/wifi-psdu.h"
 
@@ -34,12 +35,12 @@
 
 DsssPpdu::DsssPpdu(Ptr<const WifiPsdu> psdu,
                    const WifiTxVector& txVector,
-                   uint16_t txCenterFreq,
+                   const WifiPhyOperatingChannel& channel,
                    Time ppduDuration,
                    uint64_t uid)
-    : WifiPpdu(psdu, txVector, txCenterFreq, uid)
+    : WifiPpdu(psdu, txVector, channel, uid)
 {
-    NS_LOG_FUNCTION(this << psdu << txVector << txCenterFreq << ppduDuration << uid);
+    NS_LOG_FUNCTION(this << psdu << txVector << channel << ppduDuration << uid);
     SetPhyHeaders(txVector, ppduDuration);
 }
 
@@ -47,14 +48,7 @@
 DsssPpdu::SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration)
 {
     NS_LOG_FUNCTION(this << txVector);
-
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    DsssSigHeader dsssSig;
-    SetDsssHeader(dsssSig, txVector, ppduDuration);
-    m_phyHeaders->AddHeader(dsssSig);
-#else
     SetDsssHeader(m_dsssSig, txVector, ppduDuration);
-#endif
 }
 
 void
@@ -73,19 +67,7 @@
     WifiTxVector txVector;
     txVector.SetPreambleType(m_preamble);
     txVector.SetChannelWidth(22);
-
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    DsssSigHeader dsssSig;
-    if (m_phyHeaders->PeekHeader(dsssSig) == 0)
-    {
-        NS_FATAL_ERROR("Missing DSSS SIG PHY header in DSSS PPDU");
-    }
-
-    SetTxVectorFromDsssHeader(txVector, dsssSig);
-#else
     SetTxVectorFromDsssHeader(txVector, m_dsssSig);
-#endif
-
     return txVector;
 }
 
@@ -98,18 +80,9 @@
 Time
 DsssPpdu::GetTxDuration() const
 {
-    Time ppduDuration = Seconds(0);
     const WifiTxVector& txVector = GetTxVector();
-    uint16_t length = 0;
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    DsssSigHeader dsssSig;
-    m_phyHeaders->PeekHeader(dsssSig);
-    length = dsssSig.GetLength();
-#else
-    length = m_dsssSig.GetLength();
-#endif
-    ppduDuration = MicroSeconds(length) + WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
-    return ppduDuration;
+    const auto length = m_dsssSig.GetLength();
+    return (MicroSeconds(length) + WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector));
 }
 
 Ptr<WifiPpdu>
@@ -124,34 +97,6 @@
 {
 }
 
-TypeId
-DsssPpdu::DsssSigHeader::GetTypeId()
-{
-    static TypeId tid = TypeId("ns3::DsssSigHeader")
-                            .SetParent<Header>()
-                            .SetGroupName("Wifi")
-                            .AddConstructor<DsssSigHeader>();
-    return tid;
-}
-
-TypeId
-DsssPpdu::DsssSigHeader::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
-void
-DsssPpdu::DsssSigHeader::Print(std::ostream& os) const
-{
-    os << "SIGNAL=" << GetRate() << " LENGTH=" << m_length;
-}
-
-uint32_t
-DsssPpdu::DsssSigHeader::GetSerializedSize() const
-{
-    return 6;
-}
-
 void
 DsssPpdu::DsssSigHeader::SetRate(uint64_t rate)
 {
@@ -218,24 +163,4 @@
     return m_length;
 }
 
-void
-DsssPpdu::DsssSigHeader::Serialize(Buffer::Iterator start) const
-{
-    start.WriteU8(m_rate);
-    start.WriteU8(0); /* SERVICE */
-    start.WriteU16(m_length);
-    start.WriteU16(0); /* CRC */
-}
-
-uint32_t
-DsssPpdu::DsssSigHeader::Deserialize(Buffer::Iterator start)
-{
-    Buffer::Iterator i = start;
-    m_rate = i.ReadU8();
-    i.ReadU8(); /* SERVICE */
-    m_length = i.ReadU16();
-    i.ReadU16(); /* CRC */
-    return i.GetDistanceFrom(start);
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-ht/dsss-ppdu.h ns-3.39/src/wifi/model/non-ht/dsss-ppdu.h
--- ns-3.38/src/wifi/model/non-ht/dsss-ppdu.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/non-ht/dsss-ppdu.h	2023-07-05 14:23:48.113428400 -0700
@@ -22,7 +22,6 @@
 #ifndef DSSS_PPDU_H
 #define DSSS_PPDU_H
 
-#include "ns3/header.h"
 #include "ns3/wifi-ppdu.h"
 
 /**
@@ -49,24 +48,12 @@
      * DSSS SIG PHY header.
      * See section 16.2.2 in IEEE 802.11-2016.
      */
-    class DsssSigHeader : public Header
+    class DsssSigHeader
     {
       public:
         DsssSigHeader();
 
         /**
-         * \brief Get the type ID.
-         * \return the object TypeId
-         */
-        static TypeId GetTypeId();
-
-        TypeId GetInstanceTypeId() const override;
-        void Print(std::ostream& os) const override;
-        uint32_t GetSerializedSize() const override;
-        void Serialize(Buffer::Iterator start) const override;
-        uint32_t Deserialize(Buffer::Iterator start) override;
-
-        /**
          * Fill the RATE field of L-SIG (in bit/s).
          *
          * \param rate the RATE field of L-SIG expressed in bit/s
@@ -101,13 +88,13 @@
      *
      * \param psdu the PHY payload (PSDU)
      * \param txVector the TXVECTOR that was used for this PPDU
-     * \param txCenterFreq the center frequency (MHz) that was used for this PPDU
+     * \param channel the operating channel of the PHY used to transmit this PPDU
      * \param ppduDuration the transmission duration of this PPDU
      * \param uid the unique ID of this PPDU
      */
     DsssPpdu(Ptr<const WifiPsdu> psdu,
              const WifiTxVector& txVector,
-             uint16_t txCenterFreq,
+             const WifiPhyOperatingChannel& channel,
              Time ppduDuration,
              uint64_t uid);
 
@@ -145,10 +132,8 @@
     virtual void SetTxVectorFromDsssHeader(WifiTxVector& txVector,
                                            const DsssSigHeader& dsssSig) const;
 
-#ifndef NS3_BUILD_PROFILE_DEBUG
     DsssSigHeader m_dsssSig; //!< the DSSS SIG PHY header
-#endif
-}; // class DsssPpdu
+};                           // class DsssPpdu
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-ht/erp-ofdm-phy.cc ns-3.39/src/wifi/model/non-ht/erp-ofdm-phy.cc
--- ns-3.38/src/wifi/model/non-ht/erp-ofdm-phy.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/non-ht/erp-ofdm-phy.cc	2023-07-05 14:23:48.117428300 -0700
@@ -116,9 +116,7 @@
     return Create<ErpOfdmPpdu>(
         psdus.begin()->second,
         txVector,
-        m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(
-            txVector.GetChannelWidth()),
-        m_wifiPhy->GetPhyBand(),
+        m_wifiPhy->GetOperatingChannel(),
         m_wifiPhy->GetLatestPhyEntity()->ObtainNextUid(
             txVector)); // use latest PHY entity to handle MU-RTS sent with non-HT rate
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-ht/erp-ofdm-ppdu.cc ns-3.39/src/wifi/model/non-ht/erp-ofdm-ppdu.cc
--- ns-3.38/src/wifi/model/non-ht/erp-ofdm-ppdu.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/non-ht/erp-ofdm-ppdu.cc	2023-07-05 14:23:48.117428300 -0700
@@ -23,6 +23,7 @@
 #include "erp-ofdm-phy.h"
 
 #include "ns3/log.h"
+#include "ns3/wifi-phy-operating-channel.h"
 #include "ns3/wifi-psdu.h"
 
 namespace ns3
@@ -32,12 +33,11 @@
 
 ErpOfdmPpdu::ErpOfdmPpdu(Ptr<const WifiPsdu> psdu,
                          const WifiTxVector& txVector,
-                         uint16_t txCenterFreq,
-                         WifiPhyBand band,
+                         const WifiPhyOperatingChannel& channel,
                          uint64_t uid)
-    : OfdmPpdu(psdu, txVector, txCenterFreq, band, uid, true) // add LSigHeader of OfdmPpdu
+    : OfdmPpdu(psdu, txVector, channel, uid, true) // add LSigHeader of OfdmPpdu
 {
-    NS_LOG_FUNCTION(this << psdu << txVector << txCenterFreq << band << uid);
+    NS_LOG_FUNCTION(this << psdu << txVector << channel << uid);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-ht/erp-ofdm-ppdu.h ns-3.39/src/wifi/model/non-ht/erp-ofdm-ppdu.h
--- ns-3.38/src/wifi/model/non-ht/erp-ofdm-ppdu.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/non-ht/erp-ofdm-ppdu.h	2023-07-05 14:23:48.117428300 -0700
@@ -49,14 +49,12 @@
      *
      * \param psdu the PHY payload (PSDU)
      * \param txVector the TXVECTOR that was used for this PPDU
-     * \param txCenterFreq the center frequency (MHz) that was used for this PPDU
-     * \param band the WifiPhyBand used for the transmission of this PPDU
+     * \param channel the operating channel of the PHY used to transmit this PPDU
      * \param uid the unique ID of this PPDU
      */
     ErpOfdmPpdu(Ptr<const WifiPsdu> psdu,
                 const WifiTxVector& txVector,
-                uint16_t txCenterFreq,
-                WifiPhyBand band,
+                const WifiPhyOperatingChannel& channel,
                 uint64_t uid);
 
     Ptr<WifiPpdu> Copy() const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-ht/ofdm-phy.cc ns-3.39/src/wifi/model/non-ht/ofdm-phy.cc
--- ns-3.38/src/wifi/model/non-ht/ofdm-phy.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/non-ht/ofdm-phy.cc	2023-07-05 14:23:48.117428300 -0700
@@ -298,9 +298,7 @@
     return Create<OfdmPpdu>(
         psdus.begin()->second,
         txVector,
-        m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(
-            txVector.GetChannelWidth()),
-        m_wifiPhy->GetPhyBand(),
+        m_wifiPhy->GetOperatingChannel(),
         m_wifiPhy->GetLatestPhyEntity()->ObtainNextUid(
             txVector)); // use latest PHY entity to handle MU-RTS sent with non-HT rate
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-ht/ofdm-ppdu.cc ns-3.39/src/wifi/model/non-ht/ofdm-ppdu.cc
--- ns-3.38/src/wifi/model/non-ht/ofdm-ppdu.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/non-ht/ofdm-ppdu.cc	2023-07-05 14:23:48.117428300 -0700
@@ -24,6 +24,7 @@
 #include "ofdm-phy.h"
 
 #include "ns3/log.h"
+#include "ns3/wifi-phy-operating-channel.h"
 #include "ns3/wifi-phy.h"
 #include "ns3/wifi-psdu.h"
 
@@ -34,15 +35,13 @@
 
 OfdmPpdu::OfdmPpdu(Ptr<const WifiPsdu> psdu,
                    const WifiTxVector& txVector,
-                   uint16_t txCenterFreq,
-                   WifiPhyBand band,
+                   const WifiPhyOperatingChannel& channel,
                    uint64_t uid,
                    bool instantiateLSig /* = true */)
-    : WifiPpdu(psdu, txVector, txCenterFreq, uid),
-      m_band(band),
+    : WifiPpdu(psdu, txVector, channel, uid),
       m_channelWidth(txVector.IsNonHtDuplicate() ? 20 : txVector.GetChannelWidth())
 {
-    NS_LOG_FUNCTION(this << psdu << txVector << txCenterFreq << band << uid);
+    NS_LOG_FUNCTION(this << psdu << txVector << channel << uid);
     if (instantiateLSig)
     {
         SetPhyHeaders(txVector, psdu->GetSize());
@@ -53,14 +52,7 @@
 OfdmPpdu::SetPhyHeaders(const WifiTxVector& txVector, std::size_t psduSize)
 {
     NS_LOG_FUNCTION(this << txVector << psduSize);
-
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    LSigHeader lSig;
-    SetLSigHeader(lSig, txVector, psduSize);
-    m_phyHeaders->AddHeader(lSig);
-#else
     SetLSigHeader(m_lSig, txVector, psduSize);
-#endif
 }
 
 void
@@ -75,19 +67,7 @@
 {
     WifiTxVector txVector;
     txVector.SetPreambleType(m_preamble);
-
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    LSigHeader lSig;
-    if (m_phyHeaders->PeekHeader(lSig) == 0)
-    {
-        NS_FATAL_ERROR("Missing L-SIG in PPDU");
-    }
-
-    SetTxVectorFromLSigHeader(txVector, lSig);
-#else
     SetTxVectorFromLSigHeader(txVector, m_lSig);
-#endif
-
     return txVector;
 }
 
@@ -104,15 +84,9 @@
 OfdmPpdu::GetTxDuration() const
 {
     const WifiTxVector& txVector = GetTxVector();
-    uint16_t length = 0;
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    LSigHeader lSig;
-    m_phyHeaders->PeekHeader(lSig);
-    length = lSig.GetLength();
-#else
-    length = m_lSig.GetLength();
-#endif
-    return WifiPhy::CalculateTxDuration(length, txVector, m_band);
+    const auto length = m_lSig.GetLength();
+    NS_ASSERT(m_operatingChannel.IsSet());
+    return WifiPhy::CalculateTxDuration(length, txVector, m_operatingChannel.GetPhyBand());
 }
 
 Ptr<WifiPpdu>
@@ -127,34 +101,6 @@
 {
 }
 
-TypeId
-OfdmPpdu::LSigHeader::GetTypeId()
-{
-    static TypeId tid = TypeId("ns3::LSigHeader")
-                            .SetParent<Header>()
-                            .SetGroupName("Wifi")
-                            .AddConstructor<LSigHeader>();
-    return tid;
-}
-
-TypeId
-OfdmPpdu::LSigHeader::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
-void
-OfdmPpdu::LSigHeader::Print(std::ostream& os) const
-{
-    os << "SIGNAL=" << GetRate() << " LENGTH=" << m_length;
-}
-
-uint32_t
-OfdmPpdu::LSigHeader::GetSerializedSize() const
-{
-    return 3;
-}
-
 void
 OfdmPpdu::LSigHeader::SetRate(uint64_t rate, uint16_t channelWidth)
 {
@@ -266,33 +212,4 @@
     return m_length;
 }
 
-void
-OfdmPpdu::LSigHeader::Serialize(Buffer::Iterator start) const
-{
-    uint8_t byte = 0;
-    uint16_t bytes = 0;
-
-    byte |= m_rate;
-    byte |= (m_length & 0x07) << 5;
-    start.WriteU8(byte);
-
-    bytes |= (m_length & 0x0ff8) >> 3;
-    start.WriteU16(bytes);
-}
-
-uint32_t
-OfdmPpdu::LSigHeader::Deserialize(Buffer::Iterator start)
-{
-    Buffer::Iterator i = start;
-
-    uint8_t byte = i.ReadU8();
-    m_rate = byte & 0x0f;
-    m_length = (byte >> 5) & 0x07;
-
-    uint16_t bytes = i.ReadU16();
-    m_length |= (bytes << 3) & 0x0ff8;
-
-    return i.GetDistanceFrom(start);
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-ht/ofdm-ppdu.h ns-3.39/src/wifi/model/non-ht/ofdm-ppdu.h
--- ns-3.38/src/wifi/model/non-ht/ofdm-ppdu.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/non-ht/ofdm-ppdu.h	2023-07-05 14:23:48.117428300 -0700
@@ -22,7 +22,6 @@
 #ifndef OFDM_PPDU_H
 #define OFDM_PPDU_H
 
-#include "ns3/header.h"
 #include "ns3/wifi-phy-band.h"
 #include "ns3/wifi-ppdu.h"
 
@@ -51,24 +50,12 @@
      * OFDM and ERP OFDM L-SIG PHY header.
      * See section 17.3.4 in IEEE 802.11-2016.
      */
-    class LSigHeader : public Header
+    class LSigHeader
     {
       public:
         LSigHeader();
 
         /**
-         * \brief Get the type ID.
-         * \return the object TypeId
-         */
-        static TypeId GetTypeId();
-
-        TypeId GetInstanceTypeId() const override;
-        void Print(std::ostream& os) const override;
-        uint32_t GetSerializedSize() const override;
-        void Serialize(Buffer::Iterator start) const override;
-        uint32_t Deserialize(Buffer::Iterator start) override;
-
-        /**
          * Fill the RATE field of L-SIG (in bit/s).
          *
          * \param rate the RATE field of L-SIG expressed in bit/s
@@ -105,16 +92,14 @@
      *
      * \param psdu the PHY payload (PSDU)
      * \param txVector the TXVECTOR that was used for this PPDU
-     * \param txCenterFreq the center frequency (MHz) that was used for this PPDU
-     * \param band the WifiPhyBand used for the transmission of this PPDU
+     * \param channel the operating channel of the PHY used to transmit this PPDU
      * \param uid the unique ID of this PPDU
      * \param instantiateLSig flag used to instantiate LSigHeader (set LSigHeader's
      *                        rate and length), should be disabled by child classes
      */
     OfdmPpdu(Ptr<const WifiPsdu> psdu,
              const WifiTxVector& txVector,
-             uint16_t txCenterFreq,
-             WifiPhyBand band,
+             const WifiPhyOperatingChannel& channel,
              uint64_t uid,
              bool instantiateLSig = true);
 
@@ -122,10 +107,7 @@
     Ptr<WifiPpdu> Copy() const override;
 
   protected:
-    WifiPhyBand m_band; //!< the WifiPhyBand used to transmit that PPDU
-#ifndef NS3_BUILD_PROFILE_DEBUG
     LSigHeader m_lSig; //!< the L-SIG PHY header
-#endif
 
   private:
     WifiTxVector DoGetTxVector() const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-inheritance.cc ns-3.39/src/wifi/model/non-inheritance.cc
--- ns-3.38/src/wifi/model/non-inheritance.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/wifi/model/non-inheritance.cc	2023-07-05 14:23:48.117428300 -0700
@@ -0,0 +1,106 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "non-inheritance.h"
+
+#include <algorithm>
+#include <iterator>
+
+namespace ns3
+{
+
+WifiInformationElementId
+NonInheritance::ElementId() const
+{
+    return IE_EXTENSION;
+}
+
+WifiInformationElementId
+NonInheritance::ElementIdExt() const
+{
+    return IE_EXT_NON_INHERITANCE;
+}
+
+void
+NonInheritance::Print(std::ostream& os) const
+{
+    os << "NonInheritance=[";
+    std::copy(m_elemIdList.cbegin(), m_elemIdList.cend(), std::ostream_iterator<uint16_t>(os, " "));
+    os << "][";
+    std::copy(m_elemIdExtList.cbegin(),
+              m_elemIdExtList.cend(),
+              std::ostream_iterator<uint16_t>(os, " "));
+    os << "]";
+}
+
+uint16_t
+NonInheritance::GetInformationFieldSize() const
+{
+    uint16_t size = 1; // Element ID Extension
+    size += 1 /* Length */ + m_elemIdList.size();
+    size += 1 /* Length */ + m_elemIdExtList.size();
+    return size;
+}
+
+void
+NonInheritance::SerializeInformationField(Buffer::Iterator start) const
+{
+    start.WriteU8(m_elemIdList.size());
+    for (const auto id : m_elemIdList)
+    {
+        start.WriteU8(id);
+    }
+    start.WriteU8(m_elemIdExtList.size());
+    for (const auto id : m_elemIdExtList)
+    {
+        start.WriteU8(id);
+    }
+}
+
+uint16_t
+NonInheritance::DeserializeInformationField(Buffer::Iterator start, uint16_t length)
+{
+    auto i = start;
+    auto count = i.ReadU8();
+    for (uint8_t j = 0; j < count; j++)
+    {
+        m_elemIdList.emplace(i.ReadU8());
+    }
+    count = i.ReadU8();
+    for (uint8_t j = 0; j < count; j++)
+    {
+        m_elemIdExtList.emplace(i.ReadU8());
+    }
+    return i.GetDistanceFrom(start);
+}
+
+void
+NonInheritance::Add(uint8_t elemId, uint8_t elemIdExt)
+{
+    elemId != IE_EXTENSION ? m_elemIdList.insert(elemId) : m_elemIdExtList.insert(elemIdExt);
+}
+
+bool
+NonInheritance::IsPresent(uint8_t elemId, uint8_t elemIdExt) const
+{
+    return elemId != IE_EXTENSION ? m_elemIdList.count(elemId) == 1
+                                  : m_elemIdExtList.count(elemIdExt) == 1;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/non-inheritance.h ns-3.39/src/wifi/model/non-inheritance.h
--- ns-3.38/src/wifi/model/non-inheritance.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/wifi/model/non-inheritance.h	2023-07-05 14:23:48.117428300 -0700
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef NON_INHERITANCE_H
+#define NON_INHERITANCE_H
+
+#include "wifi-information-element.h"
+
+#include <set>
+
+namespace ns3
+{
+
+/**
+ * \ingroup wifi
+ *
+ * The IEEE 802.11 Non-Inheritance Information Element
+ */
+class NonInheritance : public WifiInformationElement
+{
+  public:
+    WifiInformationElementId ElementId() const override;
+    WifiInformationElementId ElementIdExt() const override;
+    void Print(std::ostream& os) const override;
+
+    /**
+     * Add the Information Element specified by the given Element ID and Element ID Extension.
+     *
+     * \param elemId the given Element ID
+     * \param elemIdExt the given Element ID Extension
+     */
+    void Add(uint8_t elemId, uint8_t elemIdExt = 0);
+
+    /**
+     * \param elemId the given Element ID
+     * \param elemIdExt the given Element ID Extension
+     * \return whether the Information Element specified by the given Element ID and
+     *         Element ID Extension is present
+     */
+    bool IsPresent(uint8_t elemId, uint8_t elemIdExt = 0) const;
+
+    std::set<uint8_t> m_elemIdList;    //!< list of unique Element ID values (in increasing order)
+    std::set<uint8_t> m_elemIdExtList; //!< list of unique Element ID Extension values
+
+  private:
+    uint16_t GetInformationFieldSize() const override;
+    void SerializeInformationField(Buffer::Iterator start) const override;
+    uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+};
+
+} // namespace ns3
+
+#endif /* NON_INHERITANCE_H */
